###########################################################################
#    Copyright (C) 2003 by Wido Depping
#    <wido.depping@tu-clausthal.de>
#
# Copyright: See COPYING file that comes with this distribution
#
###########################################################################


import sys
from qt import *

class TestWidget(QMainWindow):

	def __init__(self,parent = None,name = None,fl = 0):
		QMainWindow.__init__(self,parent,name,fl)
		self.statusBar()

		if not name:
			self.setName("TestWidget")

		self.setCentralWidget(QWidget(self,"qt_central_widget"))

		self.mainGrid = QGridLayout(self.centralWidget(), 1, 1, 11, 6)

		self.attributeFrame = QScrollView(self.centralWidget(),"attributeFrame")
		self.attributeFrame.setMinimumSize(QSize(300,100))
		self.attributeFrame.setFrameShape(QFrame.StyledPanel)
		self.attributeFrame.setFrameShadow(QFrame.Raised)
		self.attributeFrame.setResizePolicy(QScrollView.AutoOneFit)
		self.mainGrid.addWidget(self.attributeFrame,0,0)

		self.buttonFrame = QFrame(self.centralWidget(), "buttonFrame")
		self.buttonFrame.setSizePolicy(QSizePolicy(5,0,0,0,
			self.buttonFrame.sizePolicy().hasHeightForWidth()))
		self.buttonFrame.setFrameShape(QFrame.StyledPanel)
		self.buttonFrame.setFrameShadow(QFrame.Raised)
		self.buttonFrameLayout = QHBoxLayout(self.buttonFrame,11,6,"buttonFrameLayout")

		self.applyButton = QPushButton(self.buttonFrame,"applyButton")
		self.applyButton.setText("Apply")
		self.buttonFrameLayout.addWidget(self.applyButton)
		spacer = QSpacerItem(100,20,QSizePolicy.Expanding,QSizePolicy.Minimum)
		self.buttonFrameLayout.addItem(spacer)


		self.mainGrid.addWidget(self.buttonFrame,1,0)

		self.attributeWidget = QWidget(self.attributeFrame.viewport())
		self.attributeWidget.setSizePolicy(QSizePolicy.Maximum, QSizePolicy.Maximum)

		self.attributeGrid = QGridLayout(self.attributeWidget, 1, 1, 11, 6, "gridLayout")
		self.attributeFrame.addChild(self.attributeWidget)

		self.connect(self.applyButton,SIGNAL("clicked()"),self.apply_view)


		self.exitLDAPCommander = QAction(self,"exitLDAPCommander")
		self.editServerList = QAction(self,"editServerList")

		self.menubar = QMenuBar(self,"menubar")

		self.PopupMenu = QPopupMenu(self)
		self.PopupMenu2 = QPopupMenu(self)
		self.exitLDAPCommander.addTo(self.PopupMenu)
		self.editServerList.addTo(self.PopupMenu2)
		self.menubar.insertItem(QString(""),self.PopupMenu,0)
		self.menubar.insertItem(QString(""),self.PopupMenu2,1)

		self.data = ["Foo", "BLAH", "FOO2", "Holla", "hvuhuihvuiduhi" , "jklcvjdjlkd" ,
			"jvhfjdhdvjjkfjdhvjdhk", "jkmnvlfdjkdjkl", "cvjkdfvhfk", "vhjdfvhjdvhdkkd",
			"kjvjhfdhvdhk", "hjvkfkjdfdhk", "hjvdfhdfhvdkj"]

		self.languageChange()

###############################################################################

	def apply_view(self):
		for x in  self.attributeWidget.children():
			name = str(x.name())
			if name == "LDAP":
				self.attributeWidget.removeChild(x)
				del x

		for x in range(0, len(self.data)):
			tmpLabel = QLabel(self.attributeWidget, "LDAP")
			tmpLabel.setText(self.data[x])
			self.attributeGrid.addWidget(tmpLabel, x, 0)
			tmpLabel.show()

			tmpInput = QLineEdit(self.attributeWidget, "LDAP")
			tmpInput.setText(self.data[x])
			self.attributeGrid.addWidget(tmpInput, x, 1)
			tmpInput.show()

			# if creation of the button is commented out, no
			# segmentation fault
			tmpButton = QPushButton(self.attributeWidget, "LDAP")
			tmpButton.setText(self.data[x])
			self.attributeGrid.addWidget(tmpButton, x, 2)
			self.connect(tmpButton,SIGNAL("clicked()"),self.apply_view)
			tmpButton.installEventFilter(self)
			tmpButton.show()

		print self.attributeWidget.children()

###############################################################################

	def languageChange(self):
		self.editServerList.setText(self.__tr("Edit Server List"))
		self.exitLDAPCommander.setText(self.__tr("Exit"))
		self.menubar.findItem(0).setText(self.__tr("Programm"))
		self.menubar.findItem(1).setText(self.__tr("Settings"))

###############################################################################

	def __tr(self,s,c = None):
		return qApp.translate("TestWidget",s,c)


	def eventFilter(self, object, event):
		if (event.type() == QEvent.MouseButtonPress):
			name = str(object.name())
			self.data.append("dhjfshksk")
		return 0

###############################################################################

if __name__ == "__main__":
	a = QApplication(sys.argv)
	QObject.connect(a,SIGNAL("lastWindowClosed()"),a,SLOT("quit()"))
	w = TestWidget()
	a.setMainWidget(w)
	w.show()
	a.exec_loop()
